;*******************************************************************************
;				RDA5807M_&_WH1602_V4_3.asm
;	 FM-   RDA5807M  LCD- WH1602
;  ATMEGA8    .  8 .
; 		  :
;-*-         CH+  CH-.
;-*-       00.
;-*-         
;        CH+.
;-*-  ,         , 
;             CH+  CH-.
;-*-        .
;-*-       .
;-*-    .
;-*-       EEPROM.
;-*-         
;      . 
;-*-         V+  V-.
;-*-        .
;-*-        00  16.
;-*-       .
;-*-  "-" .
;-*-          10 .

;
;  :
; PD0 - D7 -    WH1602A
; PD1 - D6 -    WH1602A
; PD2 - D5 -    WH1602A
; PD3 - D4 -    WH1602A
; PD4 - E  -   WH1602A
; PD5 - RS -   WH1602A
; PD7 - .   -
;
; PC0 -  V+  
; PC1 -  V-  
; PC2 -  CH+   
; PC3 -  CH-   
; PC4 - (SDA) -    I2C
; PC5 - (SCL) -    I2C
;
;*******************************************************************************
	;     /
    .NOLIST                 ; 
	.include "m8def.inc"	;   - ATMega8
    .LIST                   ; 
    .device ATmega8         ; 
    #define F_CPU (8000000) ; 
	
  	;   
	.def temp  = r16 		;
	.def temp1 = r17 		; 
	.def temp2 = r18 		; 
	.def temp3 = r19 		;  
	.def time  = r21		;  
	.def F_3H  = r22		;.   
	.def F_3L  = r23		;.   
	.def freq  = r24		;   ( )
	
	.equ Tm_l   = 255		;  
;===============================================================================
	.DSEG				;    SRAM ()
	.ORG 0x060			;   
	decnum:		.BYTE 5		;A    
	seek_fm:	.byte 1		;  
	read_fm:	.byte 1 	; ()  
	level:		.byte 1		; 
	volume:		.byte 1		;
	
;=============================================================================
	.ESEG				;    EEPROM
	 Fst_EE:	.BYTE 1 		;   ( )
	 Vol_EE:	.BYTE 1 		; 
;=============================================================================
	.CSEG				;  
	.ORG 0 				; 
	rjmp RESET			;Reset
	reti				;  INT 0
	reti				;  INT 1
	reti				; / 2  
	rjmp OVF_T2			; / 2  
	reti  				; / 1   
	reti				; / 1     
	reti				; / 1     
	reti				; / 1  
	rjmp OVF_T0			; / 0  
	reti				;  SPI 
	reti				; UART   
	reti				; UART   
	reti				; UART  
	reti 				;   
	reti				; EEPROM 
	reti				;   
	reti    			;  - 2- 
	reti				; SPM
	
;============================================================================
RESET:		;   ,  
		;  
		LDI 	Temp, LOW(RAMEND)
		OUT 	SPL, Temp
		LDI 	Temp, HIGH(RAMEND)
		OUT 	SPH, Temp
		CLI							;   
;-----------------------------------------------------------------------------
		;  B
		ldi temp,0b01000001			;
		out DDRB,temp   			;
		ldi temp,0b11111110			;
		out PORTB,temp   			;   D
			;  ,  .  
	 	ldi temp,0b00000000			;      
		out DDRC,temp   			;
		ldi temp,0b11111111			;
		out PORTC,temp   			;  
		
			;  D,  .  LCD-
	 	ldi temp,0b11111111			;   D  
		out DDRD,temp				;
		ldi temp,0					;
		out PORTD,temp				;   D  
		
			;  0
		;  :
		; (1/8000000)*1024)*256=0,032768  = 32,768   . 1/1024
		clr temp					;    T0 
		out TCNT0,temp				;
		ldi temp,0b00000101			;  0   1/1024
		out TCCR0,temp				;
		ldi temp,0b01000001			; .    T0
		out TIMSK,temp				;
		
		sei                         ;  
		
;----------------------------------------------------------------------
	.MACRO DELAY					; 1   32 
		ldi time,@0					;    0
 		tst time					;,  0  R21  0
		brne PC-1					;
	.ENDMACRO
	
	.MACRO LOAD_ADDR 		 		;  16  
		ldi @0l,low(@1)   			;: LOAD_ADDR Z,12365
		ldi @0h,high(@1)  			;
	.ENDMACRO
;===================   ==================================
		;  
		ldi temp,Tm_l				; 
		mov R12,temp				;  
		sbi PORTB,PB0				;  
		ldi temp,0b00000111			;  2   1/1024
		out TCCR2,temp				;
		; LCD 
		rcall lcd_init				; LCD 
		ldi r16,0x0					;    
		rcall LCD_SetAddressDD		;    LCD 
		;    
		LOAD_ADDR Z,Mesg_1*2		;.  Z  . "     MHz     "
		rcall LCD_WriteString		;   
		;    
		ldi r16,0x1					;   LCD
		rcall LCD_SetAddressDD		;    LCD 
		ldi r16,2					;  0
		rcall LCD_WriteData			;   LCD
		ldi r16,2					;  0
		rcall LCD_WriteData			;   LCD
;------------------------------------------------------------------------------
		;  RDA5807
		rcall IIC_init				;  I2C
		ldi YL,LOW(Fst_EE)			;.  Y ..  
		clr YH						;
		ldi temp,15					; 
		sts volume,temp				;   = 15
		rcall Rd_St					;     EEPROM
		cpi freq,210				;    >210,
		brlo PC+2					; .. 210+870=1080,
		clr freq					;  freq =0
		DELAY 20					; 656 
		lds temp,volume				;    
		andi temp,0x0F				;  
		mov R10,temp				;
		;      
		rcall Prnt_F				;   
		rcall rekog					;/  
		;    
		rcall ch_st					; RDA5807
		DELAY 20					; 656 
		; 
		clr R2						;  
		clr R8						;   
	;	clr R10						; 
		clr R13						;  . . 
		clr freq					;  
		clr temp3					;  R19
		
		sbis PINC,PC2				;   H+ ,-
		inc R8						;   
		
;-------------------- ----------------------------------------------
main: 			; 
		in temp,PINC				; 
		com temp					; 
		andi temp,0x0F				;  
		mov r1,temp					;  R1   
		;   ()
		DELAY 1						; 32  
		tst R2						;   ,
		breq main					;   
		
lng_ts:		;  
		ldi temp,Tm_l				; 
		mov R12,temp				;  
		sbi PORTB,PB0				;  
		ldi temp,0b00000111			;  2   1/1024
		out TCCR2,temp				;
		; 
reg_V:	sbrc R2,0					;   V+
		rcall vol_up				;    
		sbrc R2,1					;   V-
		rcall vol_dw				;    
		
		sbrc R2,0					;   V+
		rjmp m_loop					;
		sbrc R2,1					;   V-
		rjmp m_loop					;
		
		tst R8						;  :
		breq hand					; -    
		
		;
avto:	sbrc R2,2					;   CH+
		rcall freq_Up				;    
		sbrc R2,3					;   CH-
		rcall freq_Down				;    
		DELAY 1						; 32  
		rjmp m_loop					;
		
		;  
hand:	sbrc R2,2					;   CH+
		rcall Num_Up				;     
		sbrc R2,3					;   CH-
		rcall Num_Down				;     
		
prn_num: 	;    
		sbis PINC,PC2				;   CH+  
		rjmp m_loop					;
		sbis PINC,PC3				;  CH-  
		rjmp m_loop					;
		rcall ch_seek				;  
		
m_loop: clr R2						;  
		clr R1						;  
		rjmp main					;   
		;
;===========================================================================
 Num_Up:			;   
 		clr R1						;
 		inc R9						;  
		mov temp,R9					;
 		cpi temp,Nst				;    > Nst
 		brmi PC+2					;
 		clr  R9						;    0
		rcall type_ch				;    LCD 
		DELAY 15					;
 		clr temp					;
 		
 		ret
 		
 ;===========================================================================
 Num_Down:			;   
 		clr R1						;  
		dec R9						;   ,
 		tst R9						;   > 0,  
 		brpl um_nom					;   ,  -
 		ldi temp,Nst-1				;
 		mov R9,temp					;
 um_nom:
 		rcall type_ch				;    LCD 
 		DELAY 15					;
		clr temp					;
 		
 		ret
 		
;===========================================================================
;		/     LCD 
;---------------------------------------------------------------------------
type_ch:	;    LCD
		ldi r16,0x40				;    
		rcall LCD_SetAddressDD		;    LCD 
		LOAD_ADDR Z,Messg6*2		;.  Z  . "     channel    "
		rcall LCD_WriteString		;   
		
		ldi r16,0x40				;    
		rcall LCD_SetAddressDD		;    LCD 
		
			;    10- 
		clr temp1					;
		mov temp,R9					;  
		inc temp					;   1
		rcall bin16_dec5			;  10- 
		ldi YL,LOW(decnum)			;.  X . .   
		clr YH						;
		inc YL						; .    
			;    LCD 
		ld temp,Y					; .   
		tst r16						;    0,  -
		brne PC+2					;    
	;	ldi r16,0x20				;
	;	rcall LCD_WriteData			;  LCD 
		rjmp PC+2					;
		rcall LCD_WriteHexDigit		; .   LCD
		ld temp,-Y					; .   
		rcall LCD_WriteHexDigit		; .   LCD
		
		ret
		
;===========================================================================
freq_Up:	;   "+"   
		cli							; 
		clr R1						;  
		inc freq					; 
		cpi freq,210				;    >210,
		brlo PC+2					; .. 210+870=1080,
		clr freq					;  freq =0
			;  "Autotune"
		ldi r16,0x40				;    
		rcall LCD_SetAddressDD		;    LCD 
		LOAD_ADDR Z,Messg4*2		;.  Z   "Autotune"
		rcall LCD_WriteString		;   
		cbi PORTD,7					;  
			;     
		ldi temp,0b10010011			;(02H) ., DMUTE=0,,,
									; SEEKUP=1, SEEK=1 ( )
		mov r5,temp					; - 
r_con:	rcall Config_RDA5807		; 
		
nov_p:	DELAY 20					;
		rcall Read_RDA5807			;   RDA5807
		DELAY 5						;
		lds r17,seek_fm				;  . 
		sbrs r17,6					;STC=1?    , -
		rjmp nov_p					;  . 
		
		rcall Read_RDA5807			;   RDA5807
		DELAY 5						;
		lds freq,read_fm			;  
		lds r17,seek_fm				;  . 
		sbrs r17,5					;SF=1?   , -
		rjmp st_tn					;  
		cpi freq,210				;    >210,
		brlo PC+2					; .. 210+870=1080,
		clr freq					;  freq =0
		rjmp r_con					;  
		
		rjmp st_tn					;  
		clr temp					; temp    
		sei
 		ret
;===========================================================================
freq_Down:		;   "-"   
		cli							; 
		clr R1						;  
		dec freq					; 
			;  "Autotune"
nastr:	ldi r16,0x40				;    
		rcall LCD_SetAddressDD		;    LCD 
		LOAD_ADDR Z,Messg4*2		;.  Z   "Autotune"
		rcall LCD_WriteString		;   
		cbi PORTD,7					;  
			;     
		ldi temp,0b10010001			;(02H) ., DMUTE=0,,,
									; SEEKUP=0, SEEK=1 ( )
		mov r5,temp					; - 
rm_con:	rcall Config_RDA5807		; 
		
nov_m:	DELAY 20					;
		rcall Read_RDA5807			;   RDA5807
		DELAY 5						;
		lds r17,seek_fm				;  . 
		sbrs r17,6					;STC=1?    , -
		rjmp nov_m					;  . 
		
		rcall Read_RDA5807			;   RDA5807
		DELAY 5						;
		lds freq,read_fm			;  
		lds r17,seek_fm				;  . 
		sbrs r17,5					;SF=1?   , -
		rjmp st_tn					;  
		tst freq					;    =0
		brne PC+2					; .. 210+870=1080,
		ldi freq,210				;  freq =210
		rjmp rm_con					;  
		
		;     
st_tn:	ldi temp,0b11010010			;(02H) ., DMUTE=1,,,
									; SEEKUP=1, SEEK=0 ( )
		mov r5,temp					; - 
		rcall Config_RDA5807		; 
		
		sbrc r17,2					; , -
		sbi PORTD,7					;   
		rcall type_lev				;  
		rcall type_vol				;    LCD
		rcall Prnt_F				;   
		rcall rekog					; 
		clr temp					; temp    
		sei
 		ret
;===========================================================================
;	/     
;---------------------------------------------------------------------------

 ch_seek:		;     . 
 		LOAD_ADDR Z,freq_st*2		;.  Z . ..  
 		tst R9						;
 		breq st_set					;  =0,   
 		push R9						;
		adiw Z,18					;    . 
		dec R9						;
		brne PC-2					;
		pop R9						;
		
st_set:	lpm freq,Z					;   FLASH
		adiw Z,1					;    
		rcall Prnt_F				;   
		rcall Prn_Ch				;   
		;   
ch_st:	ldi temp,0b11010010			;(02H) ., DMUTE=1,,,
									;SEEKUP=1, SEEK=0 ( )
		mov r5,temp					;
		rcall Config_RDA5807		;  /
		
		cbi PORTD,7					;  
		DELAY 20					;
		rcall Read_RDA5807			;   RDA5807
		DELAY 5						;
		
		lds r17,seek_fm				;  . 
		sbrc r17,2					; , -
		sbi PORTD,7					;   
		rcall type_lev				;  
		rcall type_vol				;    LCD
		
		clr temp					; temp    
		sei
		ret
		
;===========================================================================
;		/  
;---------------------------------------------------------------------------
rekog:	cli							;
		clr R9						;  
		LOAD_ADDR Z,freq_st*2		;.  Z . ..  
rd_fr:	lpm temp,Z					;   FLASH
		cp temp,freq				;  ,   ,  -
		breq na_ind					;    
		inc R9						;  
		mov temp,R9					;  , 
		cpi temp,Nst				;    , -
		brsh fall					;  . ". "
		adiw Z,18					;   
		rjmp rd_fr					;  
		
fall:	LOAD_ADDR Z,Mesg_2*2		;  . ". "
		rjmp PC+2					;
		
na_ind:	adiw Z,1					;    
			;    
Prn_Ch:	ldi r16,0x40				;    
		rcall LCD_SetAddressDD		;    LCD 
		rcall LCD_WriteString		;    
		sei
		
		ret
		
;===========================================================================
;			 /   RDA5807M
;---------------------------------------------------------------------------
Read_RDA5807:
		cli
		rcall IIC_Start			;  
		ldi temp,0b00100001		;   021
		rcall IIC_Send			;  
		
		rcall IIC_Recieve		;(0)   
		sts seek_fm,temp		;    . 
		
		rcall IIC_Recieve		;(0L)   
		sts read_fm,temp		;     
		mov freq,temp			;     
		
		rcall IIC_Recieve_lst	;(0B)   
		lsr temp				;   
		sts level,temp			;      
		
		rcall IIC_Stop			;  
		sei
		
		ret
		
;===========================================================================
;	 /    , ( YH:YL   )
;---------------------------------------------------------------------------
Rd_St:	
		cli
		LOAD_ADDR Y,Fst_EE			;.  Y . .. 
		clr freq					;
Rd_EEF:	sbic EECR,EEWE				;   
		rjmp Rd_EEF					;
		out EEARH,YH				; .   
		out EEARL,YL				; .   
		sbi EECR,EERE				;  
		in freq,EEDR				;   . 
		
		inc YL						;
Rd_EEV:	sbic EECR,EEWE				;   
		rjmp Rd_EEV					;
		out EEARH,YH				; .   
		out EEARL,YL				; .   
		sbi EECR,EERE				;  
		in temp,EEDR				;   . 
		andi temp,0x0F				;  
		sts volume,temp				;    
		sei
		ret
;===========================================================================
; 			    RDA5807
;---------------------------------------------------------------------------
Config_RDA5807: 
		cli
		push R16          	;   R16
    	in R16,SREG      	;
   		push R16         	;   SREG
		;     
; .F_3H . 8  .  .F_3L .2  . &  ..
		mov F_3H,freq				;
		clc							;  
		clr F_3L					;
		lsr F_3H					;
		ror F_3L					;
		lsr F_3H					;
		ror F_3L					;
		ori F_3L,0x10				;   
		;     RDA5807
		rcall iic_start				; 
		ldi temp,0x20				;    RDA5807
		rcall IIC_Send				;  
		
		mov temp,r5					;   -
		rcall IIC_Send				;(02) = r5
		ldi temp,0b10000101			;(02L):  SKMODE=1 Fclk=32.768kHz,
		rcall IIC_Send				; RDS_EN=0,NEW_METHOD=1, Power Up
		
		mov temp,F_3H				;(03H) . 8  
		rcall IIC_Send				;
		mov temp,F_3L				;(03L) .2  . &  ..
		rcall IIC_Send				;	87108 MHz	 100 
		
		ldi temp,0					;(04H)
		rcall IIC_Send				;
		ldi temp,0					;(04L)
		rcall IIC_Send				;
		
		ldi temp,0b10001000 		;(05H)- .,  . 
		rcall IIC_Send				;
		lds temp,volume				;(05L)     
		ori temp,0b10000000			;
		rcall IIC_Send				;  
		
		rcall iic_stop 				; 
		rcall Wr_EEF				;    
		rcall Wr_EEV				;   
		
		pop R16          		;   SREG
    	out SREG,R16     		;
    	pop R16          		;   R16
		sei
		ret
;===========================================================================
;		    ,  YH:YL   
;---------------------------------------------------------------------------
Wr_EEF:	
		cli
		ldi YL,LOW(Fst_EE)			;.  Y . ..
		clr YH						; .   
		sbic EECR,EEWE				;  
		rjmp PC-1					;   EEWE
		out EEARH,YH				; .   
		out EEARL,YL				; .   
		out EEDR,freq				;  
		sbi EECR,EEMWE				;   
		sbi EECR,EEWE				;  
		sei
		
		ret
; ========================================================================
;		    ,  YH:YL   
;-------------------------------------------------------------------------
Wr_EEV:	
		cli
		ldi YL,LOW(Vol_EE)			;.  Y . ..
		clr YH						; .   
		lds temp,volume				;    
		sbic EECR,EEWE				;  
		rjmp PC-1					;   EEWE
		out EEARH,YH				; .   
		out EEARL,YL				; .   
		out EEDR,temp				;  
		sbi EECR,EEMWE				;   
		sbi EECR,EEWE				;  
		sei
		
		ret
; ========================================================================
		; 
vol_up:	clr R1				;
		lds temp,volume		;    
		cpi temp,15			;  
		breq vol_st			; ,  
		; 
		inc R10				;   , 
		breq PC+2			; ,    
		mov temp,R10		;
		sts volume,temp		;  
vol_st:	rcall wr_vol		;   RDA5807m
		DELAY 10			; 323 
		clr temp			; temp    
		ret
;========================================================================
		; 
vol_dw:	clr R1				;
		lds temp,volume		;    
		tst temp			;  .  0,  -
		brne v_down			;
		rcall mute			;    ,
		dec R10				;
		rcall type_vol		;   
		rjmp vol_mi			;
		
v_down:	dec temp			; 
		brpl PC+2			;  <0, 
		clr temp			;  
		mov R10,temp		;
		sts volume,temp		;  
		rcall wr_vol		;   RDA5807m
vol_mi:	DELAY 10			; 323 
		clr temp			; temp    
		ret
		
; ========================================================================
; /    RDA5807M     0x22
;-------------------------------------------------------------------------
mute:	cli
		rcall iic_start				;  ""
		ldi temp,0x22				;  
		rcall IIC_Send				;  
		
		ldi temp,0x02				;  (02H)  
		rcall IIC_Send				;  
		
		ldi temp,0b10010010			;(02H): ., DMUTE=0,,,
		rcall IIC_Send				;SEEKUP=1, SEEK=0 ( )
		ldi temp,0b10000101			;(02L):  SKMODE=1 Fclk=32.768kHz,
		rcall IIC_Send				; RDS_EN=0,NEW_METHOD=1, Power Up

		rcall iic_stop 				;  ""
		sei
		
		ret

; ========================================================================
; /    RDA5807M     0x22
;-------------------------------------------------------------------------
wr_vol:	;     RDA5807
		cli
		; 
		rcall iic_start				;  ""
		ldi temp,0x22				;  
		rcall IIC_Send				;  
		
		ldi temp,0x02				;  (02H)  
		rcall IIC_Send				;  
			
		ldi temp,0b11010010			;(02H): ., DMUTE=1,,,
		rcall IIC_Send				;SEEKUP=1, SEEK=0 ( )
		ldi temp,0b10000101			;(02L):  SKMODE=1 Fclk=32.768kHz,
		rcall IIC_Send				; RDS_EN=0,NEW_METHOD=1, Power Up
		
		rcall iic_stop 				;  ""
		;    
		rcall iic_start				;  ""
		ldi temp,0x22				;  
		rcall IIC_Send				;  
		
		ldi temp,0x05				;  (05H)  
		rcall IIC_Send				;
		
		ldi temp,0b10001000  		;(05H) - .,  . 
		rcall IIC_Send				;
		lds temp,volume				;(05L)     
		ori temp,0b10000000			;
		rcall IIC_Send				;   RDA5807m
		
		rcall iic_stop 				;  ""
		rcall type_vol				;   
		sei
		
		ret
;===========================================================================
;		/     LCD 
;---------------------------------------------------------------------------
type_vol:	;    LCD
		ldi r16,14					;
		rcall LCD_SetAddressDD		;    LCD 
		LOAD_ADDR Z,Messg3*2		;.  Z  . "    "
		rcall LCD_WriteString		;    
		ldi r16,13					;
		rcall LCD_SetAddressDD		;    LCD 
		ldi r16,0					;
		rcall LCD_WriteData			;    LCD
		ldi r16,14					;
		rcall LCD_SetAddressDD		;    LCD 
		
			;   10- 
		clr R17						;
		lds temp,volume				;    
		andi temp,0x0F				;  
		
		tst R10						;  ,  -
		brpl PC+5					;
		ldi temp,0xFF				;   - 
		mov R10,temp				;
		clr temp					;      00,
		rjmp prbr					; , -  
		inc temp					;  1 
		
prbr:	rcall bin16_dec5			;  10- 
		ldi YL,LOW(decnum)			;.  X . .   
		clr YH						;
		inc YL						; .    
			;    LCD 
		ld temp,Y					; .  
		rcall LCD_WriteHexDigit		; .    LCD
		ld temp,-Y					; .  
		rcall LCD_WriteHexDigit		; .    LCD
		
		ret
		
;===========================================================================
;		/     LCD 
;---------------------------------------------------------------------------
type_lev:
		cli
		;    LCD
		ldi r16,0x1					;   LCD
		rcall LCD_SetAddressDD		;    LCD 
		
		lds temp,level				;     
		
		cpi temp,51					; 4- 
		brmi PC+6					;
		
		; 4-  
		ldi r16,4					; 
		rcall LCD_WriteData			;   LCD
		ldi r16,6					; 
		rcall LCD_WriteData			;   LCD
		rjmp tp_lev					;    /
		
		cpi temp,38					; 3- 
		brmi PC+6					;
		
		; 3-  
		ldi r16,4					; 
		rcall LCD_WriteData			;   LCD
		ldi r16,5					; 
		rcall LCD_WriteData			;   LCD
		rjmp tp_lev					;    /
		
		cpi temp,25					; 2- 
		brmi PC+6					;
		
		; 2-  
		ldi r16,4					; 
		rcall LCD_WriteData			;   LCD
		ldi r16,2					; 
		rcall LCD_WriteData			;   LCD
		rjmp tp_lev					;    /
		
		cpi temp,12					; 1- 
		brmi PC+6					;
		
		; 1-  
		ldi r16,3					; 
		rcall LCD_WriteData			;   LCD
		ldi r16,2					; 
		rcall LCD_WriteData			;   LCD
		rjmp tp_lev					;    /
		
		; 0-  
		ldi r16,2					; 
		rcall LCD_WriteData			;   LCD
		ldi r16,2					; 
		rcall LCD_WriteData			;   LCD
		
tp_lev:	sei
		ret

;===========================================================================
; /     0
;---------------------------------------------------------------------------
OVF_T0:	
		push R16          	;   R16
    	in R16,SREG      	;
   		push R16         	;   SREG
		;
		dec time			; 
		
		tst r1				;     
		breq vyh			;   /,  -
		mov r2,r1			;    
		
vyh:	pop R16          	;   SREG
    	out SREG,R16     	;
    	pop R16          	;   R16
		
		reti
		
;===========================================================================
; /     2
;---------------------------------------------------------------------------
OVF_T2:	
		push R19          	;   R19
    	in R19,SREG      	;
   		push R19         	;   SREG
		;
podsv:	dec R12				;    , -
		brne wyh			;   /,  -
		cbi PORTB,0			;  
		ldi R19,0			;  2
		out TCCR2,R19		;
		;
wyh:	pop R19          	;   SREG
    	out SREG,R19     	;
    	pop R19          	;   R19
		
		reti
		
;===========================================================================
;		    LCD 
;---------------------------------------------------------------------------
 Prnt_F:		;      
		cli
		;    LCD
		ldi r16,0x4					;   LCD
		rcall LCD_SetAddressDD		;    LCD 
		;    
		clr r18						;
		ldi r17,HIGH(870)			;  
		ldi temp,LOW(870)			; : 870  
		add temp,freq				;   
		adc r17,r18					;
		;   10- 
		rcall bin16_dec5			;  10- 
		ldi YL,LOW(decnum+3)			;.  X . .   
		clr YH						;
		;  
		ld r16,Y					; .  
		tst r16						;    0,  -
		brne PC+4					;    
		ldi r16,0x20				;
		rcall LCD_WriteData			;  LCD 
		rjmp PC+2
		rcall LCD_WriteHexDigit		;  LCD  
		ld r16,-Y					;
		rcall LCD_WriteHexDigit		;  LCD  
		ld r16,-Y					;
		rcall LCD_WriteHexDigit		;  LCD  
		ldI r16,0x2C				;
		rcall LCD_WriteData			;  LCD 
		ld r16,-Y					;
		rcall LCD_WriteHexDigit		;  LCD   
		
		push ZL
		push ZH
		LOAD_ADDR Z,Messg5*2		;
		rcall LCD_WriteString		; . "MHz"
		pop ZH
		pop ZL
		
		sei
		ret
		
;===========================================================================
;  2-    5-
;  (  d4d0   SRAM )
;
; R17:R16    ,    (00xFFFF)
; R18,R19,R20   
; [YH:YL]        YH:YL
; decnum      
;---------------------------------------------------------------------------
 bin16_dec5:
 	cli
 	push R18
 	push R19
 	push R20
     ldi   YL,low(decnum) 	;   Y 
     ldi   YH,high(decnum) 	;    d0d4  
     ldi   R20,4    		;   
bd1: clr   R18      		;   R18
     ldi   R19,16   		;    
bd2: lsl   R16      		;   V(D)/10
     rol   R17      		;     R17:R16,
     rol   R18      		;    R18 = di
     andi  R16,0xFE
     cpi   R18,10
     brcs  bd3
     subi  R18,10
     ori   R16,0x01
bd3: dec   R19
     brne  bd2
     st    Y+,R18   		;  di  
     dec   R20
     brne  bd1      		;  n-1 
     st    Y+,R16   		;   dn-1  
    pop R20
    pop R19
    pop R18
     sei
     ret
	
;===================================================================================
			;     
  Mesg_1: .DB  7,' ',' ',' ',' ',' ',' ',' ',' ','M','H','z',' ',' ',' ',' ',0,0
  Mesg_2: .DB  'U','n','k','n','o','w',' ','c','h','a','n','n','e','l',' ',' ',0,0
 ; Messg3: .DB  ' ',' ',' ',' ', 0, 0
  Messg3: .DB  ' ',' ', 0, 0
  Messg4: .DB  ' ',' ',' ',' ','A','u','t','o','T','u','n','e',' ',' ',' ',' ', 0,0
  Messg5: .DB  'M','H','z', 0
  Messg6: .DB  ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ', 0,0

;====================================================================================
;******************************************************************************
	.include "I2C_hard_driver.asm"			;   I2C
	.include "HD44780_driver.asm" 			; LCD
	.include "User_set.asm"					; 
;******************************************************************************

	.EXIT

